exception EmptyList

let hd l = match l with
  | [] -> raise EmptyList
  | x::_ -> x

let tl l = match l with
  | [] -> raise EmptyList
  | _::q -> q

let rec length l =
  try let q = tl l in
    1 + (length q)
  with
    | EmptyList -> 0
